package multiNationSpecies;


public class Individual
{
    public double[] genes;
    public int noOfGenes = 2;// no of genes the chromosome has
    public double[] leftDomain;
    public double[] rightDomain;

    private int functionNo = 0;
    public boolean selectedForCrossover = false;
    public int formerIndex = 0;

    public boolean marked = false;//wether an individual is processed for species conservation or not
    public boolean markedAsSeeds = false;
    public int formerID = 0;//used for conservation only - in "insertSeeds()"
    public int seedID = 0;//used so that it won't be necessary to count again for the selection wich are the species
    public int oldSeedID = 0;//used in the determineSeeds method to reduce the number of fitness evaluations
    public double evaluation = -10e10;
    public boolean found = false;

    public int[] IDs;
    private int noOfIDs = 0;

    public Individual()
    {
    	genes = new double[noOfGenes];
    }

    //useful for the domain
    public Individual(int _functionNo, int _noOfGenes)
    {
        noOfGenes = _noOfGenes; 
        functionNo = _functionNo;
        if((functionNo == 7) || (functionNo == 9) || (functionNo == 10) || (functionNo == 11))// Deb's function has only one dimension
                noOfGenes = 1;
        leftDomain = new double[noOfGenes];
        rightDomain = new double[noOfGenes];
        genes = new double[noOfGenes];
        switch(functionNo)
        {
        case 1:
        	for(int i = 0; i < noOfGenes; i++)
            {
                    leftDomain[i] = -5.12;
                    rightDomain[i] = 5.12;
            }
        	break;
        case 2:
        	for(int i = 0; i < noOfGenes; i++)
            {
                    leftDomain[i] = -500;
                    rightDomain[i] = 500;
            }
        	break;
        case 3:
        	for(int i = 0; i < noOfGenes; i++)
            {
                    leftDomain[i] = -2;
                    rightDomain[i] = 2;
            }
        	break;
        case 4:
        	for(int i = 0; i < noOfGenes; i++)
            {
                    leftDomain[i] = -2;
                    rightDomain[i] = 2;
            }
        	break;
        case 5:
        	leftDomain[0] = -1.9;
            rightDomain[0] = 1.9;
            leftDomain[1] = -1.1;
            rightDomain[1] = 1.1;
        	break;
        case 6:
        	leftDomain[0] = -0.9;
            rightDomain[0] = 1.2;
            leftDomain[1] = -1.2;
            rightDomain[1] = 1.2;
        	break;
        case 7:
        	leftDomain[0] = 0;
            rightDomain[0] = 1;
            break;
        case 8:
        	leftDomain[0] = -5;
            rightDomain[0] = 10;
            leftDomain[1] = 0;
            rightDomain[1] = 15;
            break;
        case 9:
        	leftDomain[0] = 0;
            rightDomain[0] = 20;
        	break;
        case 10:
        	leftDomain[0] = 0;
            rightDomain[0] = 20;
        	break;
        case 11:
        	 leftDomain[0] = 0;
             rightDomain[0] = 30;
             break;
        case 12:
        	for(int i = 0; i < noOfGenes; i++)
            {
                    leftDomain[i] = -5.12;
                    rightDomain[i] = 5.12;
            }
        	break;
        case 13:
        	for( int i = 0; i < noOfGenes; i++ ) 
            {
                leftDomain[i] = -5;
                rightDomain[i] = 5;
            }
        	break;
        case 14:
        	leftDomain[0] = -5;
            rightDomain[0] = 10;
            leftDomain[1] = 0;
            rightDomain[1] = 15;
        	break;
        case 15:
        	for( int i = 0; i < noOfGenes; i++ ) 
            {
                leftDomain[i] = -30;
                rightDomain[i] = 30;
            }
        	break;
        case 16:
        	for( int i = 0; i < noOfGenes; i++ ) 
            {
                leftDomain[i] = -10;
                rightDomain[i] = 10;
            }
        	break;
        case 17:
        	for( int i = 0; i < noOfGenes; i++ ) 
            {
                leftDomain[i] = 0;
                rightDomain[i] = Math.PI;
            }
        	break;
        case 18:
        	leftDomain[0] = -2.8;
            rightDomain[0] = 2.8;
            leftDomain[1] = -2;
            rightDomain[1] = 2;
        	break;
        case 19:
        	leftDomain[0] = -1.9;
            rightDomain[0] = 1.9;
            leftDomain[1] = -0.11;
            rightDomain[1] = 0.11;
        	break;
        case 20:
        	for(int i = 0; i < noOfGenes; i++)
            {
                    leftDomain[i] = -5.12;
                    rightDomain[i] = 5.12;
            }
        	break;
        case 22:
        	for( int i = 0; i < noOfGenes; i++ ) 
            {
                leftDomain[i] = -5;
                rightDomain[i] = 5;
            }
        	break;
        case 34:
        	for( int i = 0; i < noOfGenes; i++ ) 
            {
                leftDomain[i] = -5;
                rightDomain[i] = 5;
            }
        	break;
        case 50:
        	for( int i = 0; i < noOfGenes; i++ ) 
            {
                leftDomain[i] = 0;
                rightDomain[i] = 10;
            }
        	break;
        default:
        	System.out.println("In Individual.java, no bounds for function " + functionNo);
        }           
    }                                               
             

    public void setGenes(double g1, double g2)
    {
        genes[0] = g1;
        genes[1] = g2;
    }

    public void setGenes(double[] g)
    {
        for(int i = 0; i < noOfGenes; i++)
            genes[i] = g[i];
    }

    public void resetID()
    {
        noOfIDs = 0;
        IDs = new int[noOfIDs];
    }

    public void setGene(double g1)
    {
        genes[0] = g1;		
    }

    public void randomInitialize()
    {	
        for (int i = 0; i < noOfGenes; i++)
            genes[i] = leftDomain[i] + (rightDomain[i] - leftDomain[i]) * Math.random();
    }

    public void addID(int newID)
    {
            if(noOfIDs == 0)
            {
                noOfIDs++;
                IDs = new int[noOfIDs];
                IDs[0] = newID;
            }
            else
            {
                int[] temp = new int[noOfIDs];
                for(int i = 0; i < noOfIDs; i++)
                    temp[i] = IDs[i];
                noOfIDs++;
                IDs = new int[noOfIDs];
                for(int i = 0; i < noOfIDs - 1; i++)
                    IDs[i] = temp[i];
                IDs[noOfIDs - 1] = newID;
            }
    }

    //writeValues() is writing the values of the current chromosome 
    public void writeValues()
    {
        System.out.println("The values of the individual");
        try
        {
            for(int i = 0; i < noOfGenes; i++)
                System.out.print(genes[i] + " ");
            System.out.println();
        }
        catch(Exception e)
        {
            System.out.println("The values of the individual cannot be shown because of the following exception \n" + e);
        }
    }
}